#ifndef _PARTICLE_GAME_H_
#define _PARTICLE_GAME_H_

//define the game world
struct World
{
	int width, height; //size of the world
	int px, py; //current position of the particle
} world;


//define event in this game world
enum EventType {KeyboardEvent, AlarmEvent};
 	
struct Event
{
	int delta_x;
	int delta_y;
	short handled;
    enum EventType type;
} event;

//pixel type: up, down, left, right, obstacle
enum TYPE {UP, DN, LF, RT, OB};

//pixel rendering
enum Color {Black=30, Red, Green, Yellow, Blue, Magenta, Cyan, White};
enum Style {Bright=1, Dim, Underscore=4, Blink, Reverse=7, Hidden};


//functions for supporting the game

//initialize the drawing
void init_draw();

//finaliza the drawing
void finish_draw(int sig);

//move the current drawing position to x, y
void moveto(int x, int y);

//set the color of the next charactors that you will draw
void set_color(enum Color foreground, enum Color background);

//set the color and style of the next charactors that you will draw
void set_color_style(enum Color foreground, enum Color background, enum Style style);

//draw a pixel at the current position
void draw_pixel(enum TYPE type);

//draw the border of the game board
void draw_boundingbox(const struct World * world);

#endif //_PARTICLE_GAME_H_
