#include <string.h>
#include <stdio.h>	/* sprintf */
#include <stdlib.h>	/* exit */
#include "timer.h"
#include "input.h"
#include "keyboard.h"

extern int close_button_pressed;

const char input_chr9[9][4] = 
{
	"LFT", "RGT", "UP", "DWN", "(A)", "(B)", "BEL", "BS", "HT"
};

int inputdevs_fd[4] = {-1,-1,-1,-1};
char inputdevs_player[4] = {0};

int autorep_a_b_btns = 0;
int edit_mode = 0;

static short spawn_tm[2];
static int ignore_dev;

void init_inputdevs()
{
	init_keybd();
}


#define player_flag(i, flags) 0

static int getkeypress_select(int tm, int flags)
{
	int keypress = 0;
	int i;

	for (i = inpselect_dev(tm); i < NUM_INPUTDEVS && !keypress; i++) {
		if (i+1 == ignore_dev)
			continue;
		switch (i) {
		case 0:
			keypress = kb_getpress(flags);
			break;
		}
	}
	if (keypress)
		keypress |= player_flag(i-1, flags);
	return keypress;
}

int getkeypress(int tm, int flags)
{
	int t = gettm(0);
	int keypress;
	if (socket_fd > -1)
		flags |= SINGLE_PL;
	while (1) {
		if (tm <= 0)
			return 0;
		keypress = getkeypress_select(tm, flags);

		if (keypress)
			break;
		if (gettm(t) == t)
			sleep_msec(1);
		tm -= gettm(t)-t;
		t = gettm(0);
	}
	return keypress;
}

int getkeypress_block(int flags)
{
	int keypress;
	while (1) {

		keypress = getkeypress(1000, flags);
		if (keypress)
			break;
		sleep_msec(55);
	}
	return keypress;
}

void spawn_discard_drops(int pl)
{
	int i = 0;
	if (pl==2) {
		i = 1;
		if (socket_fd > -1) {
			spawn_tm[1] = 0;
			return;
		}
	}
	spawn_tm[i] = gettm(0);
}

static int key_is_valid(unsigned c, int keypr)
{
	return c == (keypr & 0x7F) ||
		c > MVRIGHT &&
		(c > MVDOWN || keypr & IN_GAME) &&
		c != STARTBTN && c != '\t';
}

static int setkeymapping_keybd(int keypr)
{
	unsigned char s[5] = "";
	unsigned c;
	kb_no_autorep = 1;
	while (!kb_readkey(s)) {
		if (c = getkeypress_select(100, SINGLE_PL))
			return c;
		sleep_msec(55);
	}
	c = !s[1] ? s[0] : ESC+1;
	if (c == ESC)
		kb_rmmapping(keypr);
	else {
		if (!key_is_valid(c, keypr))
			return c;
		if (c == MVUP && (keypr & (63 | IN_GAME)) == MVUP) {
			c = kb_getchrfor(keypr);
			if (c == MVUP)
				return MVUP;
		}
		kb_setmapping(s, keypr);
		if (!c && (!(keypr & PLAYER_2) || inputdevs_player[0]==2))
			return MVUP;
	}
	return MVDOWN;
}



int setkeymapping(int dev, int keypr)
{
	ignore_dev = dev+1;
	keypr = setkeymapping_keybd(keypr);
	kb_no_autorep = 0;
	ignore_dev = 0;
	return keypr;
}

static const char *getkeyfor_str_keybd(int keypr, int *c)
{
	static unsigned char bytes[7];
	const char *name;
	int n = kb_getkeyfor(keypr, bytes, 1);
	if (!n)
		return "";
	name = kb_keyname(bytes, n);
	if (name)
		return name;
	bytes[n] = '\0';
	if (n==1)  {
		n = bytes[0];
		if (n ==' ')
			strcpy((char *) bytes, "SPACE");
		else if (n == DEL)
			strcpy((char *) bytes, "DEL");
		else if (n < ' ') {
			if (n < 10) {
				*c = n;
				return NULL;
			}
			sprintf((char *) bytes, "%d", n);
		}
	}
	return (const char *) bytes;
}

const char *getkeyfor_str(int dev, int keypr)
{
	const char *name;
	int c = 0;
	name = getkeyfor_str_keybd(keypr, &c);
	if (name)
		return name;
	if (c > 0 && c < 10)
		return input_chr9[c-1];
	return "";
}

static int dropsafe(int i)
{
	int t = spawn_tm[i];
	if (t && gettm(t)-t < DAS_DELAY)
		return 1;
	spawn_tm[i] = 0;
	return 0;
}

int processkey_ingame(int key, int flags)
{
	

	switch (key & 0x7F) {
	case ESC:
	case '\b':
		return -2;
	case 'q':
		exit(0);
	}


	/*
	switch (key) {
	case MVLEFT:
		moveleft(plr);
		break;
	case MVRIGHT:
		moveright(plr);
		break;
	case MVUP:
		rotate(plr, plr->rotationsys & ROT_CLOCKWISE);
		break;
	case A_BTN:
		rotate(plr, 1);
		break;
	case B_BTN:
		rotate(plr, 0);
		break;
	default:
		return -1;
	}
		*/

	//upd_screen(1);
	return 1;

}
